Index: palm/trunk/SOURCE/wind_turbine_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/wind_turbine_model_mod.f90	(revision 4495)
@@ -26,4 +26,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4481 2020-03-31 18:55:54Z maronga
 ! ASCII output cleanup
 ! 
@@ -154,5 +157,5 @@
         ONLY:  coupling_char,                                                  &
                debug_output,                                                   &
-               dt_3d, dz, end_time, message_string, time_since_reference_point,&
+               dt_3d, dz, end_time, message_string, restart_data_format_output, time_since_reference_point,&
                wind_turbine, initializing_actions, origin_date_time
 
@@ -185,4 +188,7 @@
     
     USE pegrid
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rrd_mpi_io_global_array, wrd_mpi_io_global_array
 
 
@@ -474,5 +480,6 @@
 
     INTERFACE wtm_rrd_global
-       MODULE PROCEDURE wtm_rrd_global
+       MODULE PROCEDURE wtm_rrd_global_ftn
+       MODULE PROCEDURE wtm_rrd_global_mpi
     END INTERFACE wtm_rrd_global
 
@@ -565,34 +572,50 @@
        
 
-       CALL wrd_write_string( 'generator_speed' )
-       WRITE ( 14 )  generator_speed
-
-       CALL wrd_write_string( 'generator_speed_f' )
-       WRITE ( 14 )  generator_speed_f
-
-       CALL wrd_write_string( 'generator_speed_f_old' )
-       WRITE ( 14 )  generator_speed_f_old
-
-       CALL wrd_write_string( 'generator_speed_old' )
-       WRITE ( 14 )  generator_speed_old
-
-       CALL wrd_write_string( 'rotor_speed' )
-       WRITE ( 14 )  rotor_speed
-
-       CALL wrd_write_string( 'yaw_angle' )
-       WRITE ( 14 )  yaw_angle
-
-       CALL wrd_write_string( 'pitch_angle' )
-       WRITE ( 14 )  pitch_angle
-
-       CALL wrd_write_string( 'pitch_angle_old' )
-       WRITE ( 14 )  pitch_angle_old
-
-       CALL wrd_write_string( 'torque_gen' )
-       WRITE ( 14 )  torque_gen
-
-       CALL wrd_write_string( 'torque_gen_old' )
-       WRITE ( 14 )  torque_gen_old
-
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+          CALL wrd_write_string( 'generator_speed' )
+          WRITE ( 14 )  generator_speed
+
+          CALL wrd_write_string( 'generator_speed_f' )
+          WRITE ( 14 )  generator_speed_f
+
+          CALL wrd_write_string( 'generator_speed_f_old' )
+          WRITE ( 14 )  generator_speed_f_old
+
+          CALL wrd_write_string( 'generator_speed_old' )
+          WRITE ( 14 )  generator_speed_old
+
+          CALL wrd_write_string( 'rotor_speed' )
+          WRITE ( 14 )  rotor_speed
+
+          CALL wrd_write_string( 'yaw_angle' )
+          WRITE ( 14 )  yaw_angle
+
+          CALL wrd_write_string( 'pitch_angle' )
+          WRITE ( 14 )  pitch_angle
+
+          CALL wrd_write_string( 'pitch_angle_old' )
+          WRITE ( 14 )  pitch_angle_old
+
+          CALL wrd_write_string( 'torque_gen' )
+          WRITE ( 14 )  torque_gen
+
+          CALL wrd_write_string( 'torque_gen_old' )
+          WRITE ( 14 )  torque_gen_old
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+          CALL wrd_mpi_io_global_array( 'generator_speed', generator_speed )
+          CALL wrd_mpi_io_global_array( 'generator_speed_f', generator_speed_f )
+          CALL wrd_mpi_io_global_array( 'generator_speed_f_old', generator_speed_f_old )
+          CALL wrd_mpi_io_global_array( 'generator_speed_old', generator_speed_old )
+          CALL wrd_mpi_io_global_array( 'rotor_speed', rotor_speed )
+          CALL wrd_mpi_io_global_array( 'yaw_angle', yaw_angle )
+          CALL wrd_mpi_io_global_array( 'pitch_angle', pitch_angle )
+          CALL wrd_mpi_io_global_array( 'pitch_angle_old', pitch_angle_old )
+          CALL wrd_mpi_io_global_array( 'torque_gen', torque_gen )
+          CALL wrd_mpi_io_global_array( 'torque_gen_old', torque_gen_old )
+
+       ENDIF
        
     END SUBROUTINE wtm_wrd_global    
@@ -602,7 +625,7 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data.
-!------------------------------------------------------------------------------!
- SUBROUTINE wtm_rrd_global( found )
+!> Read module-specific global restart data (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE wtm_rrd_global_ftn( found )
 
 
@@ -649,5 +672,26 @@
    
 
- END SUBROUTINE wtm_rrd_global
+ END SUBROUTINE wtm_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE wtm_rrd_global_mpi
+
+    CALL rrd_mpi_io_global_array( 'generator_speed', generator_speed )
+    CALL rrd_mpi_io_global_array( 'generator_speed_f', generator_speed_f )
+    CALL rrd_mpi_io_global_array( 'generator_speed_f_old', generator_speed_f_old )
+    CALL rrd_mpi_io_global_array( 'generator_speed_old', generator_speed_old )
+    CALL rrd_mpi_io_global_array( 'rotor_speed', rotor_speed )
+    CALL rrd_mpi_io_global_array( 'yaw_angle', yaw_angle )
+    CALL rrd_mpi_io_global_array( 'pitch_angle', pitch_angle )
+    CALL rrd_mpi_io_global_array( 'pitch_angle_old', pitch_angle_old )
+    CALL rrd_mpi_io_global_array( 'torque_gen', torque_gen )
+    CALL rrd_mpi_io_global_array( 'torque_gen_old', torque_gen_old )
+
+ END SUBROUTINE wtm_rrd_global_mpi
 
 
Index: palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4495)
@@ -24,4 +24,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4489 2020-04-04 10:54:08Z raasch
 ! file re-formatted to follow the PALM coding standard
 !
@@ -74,8 +77,14 @@
     USE averaging
 
+    USE bulk_cloud_model_mod,                                                                      &
+        ONLY:  bulk_cloud_model
+
     USE control_parameters
 
     USE grid_variables,                                                                            &
         ONLY:  dx, dy
+
+    USE gust_mod,                                                                                  &
+        ONLY:  gust_module_enabled
 
     USE indices,                                                                                   &
@@ -94,4 +103,7 @@
         ONLY:  netcdf_precision, output_for_t0
 
+    USE particle_attributes,                                                                       &
+        ONLY:  particle_advection
+
     USE pegrid,                                                                                    &
         ONLY:  collective_wait, hor_index_bounds, myid, numprocs
@@ -105,4 +117,7 @@
     USE random_generator_parallel,                                                                 &
         ONLY:  id_random_array, seq_random_array
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  wrd_mpi_io, wrd_mpi_io_global_array
 
     USE spectra_mod,                                                                               &
@@ -116,4 +131,7 @@
         ONLY:  surface_wrd_local
 
+    USE user,                                                                                      &
+        ONLY:  user_module_enabled
+
     USE vertical_nesting_mod,                                                                      &
         ONLY:  vnest_init
@@ -143,6 +161,7 @@
 ! Description:
 ! ------------
-!> Global data of control variables and arrays is written out for restarts (binary format).
-!> This information is only written to the file opened by PE0.
+!> Global data of control variables and arrays is written out for restarts.
+!> In case of output in Fortran binary format, this information is only written to the file
+!> opened by PE0.
 !--------------------------------------------------------------------------------------------------!
 
